(function() {
    if(!window.apeApps) {
        window.apeApps = {};
    }

    if(!window.apeApps.fileStructures) {
        window.apeApps.fileStructures = {};
    }

    window.apeApps.fileStructures.fpp = {};

    window.apeApps.fileStructures.fpp.EXT = "fpp";
    window.apeApps.fileStructures.fpp.Struct = Struct;
    window.apeApps.fileStructures.fpp.rebuildFromJSON = rebuild;
    
    function Struct() {
        this.data = [];
        this.lastSave = new Date().getTime();
        this.created = new Date().getTime();
        this.authors = [];
        this.firstAuthor = null;
        this.lastAuthor = null;
        this.height = 0;
        this.width = 0;
        this.createdApp = null;
        this.savedApp = null;
        this.createdAppVer = null;
        this.savedAppVer = null;
    }

    function rebuild(json) {

        let retSt = new Struct();

        if(typeof json == "string") {
            try {
                json = JSON.parse(json);
            } catch(ex) {
                console.log(ex);
                return retSt;
            }
        }

        for(let prop in json) {
            retSt[prop] = json[prop];
        }

        return retSt;
    }
})();